module Concerns
  module InterproMixin
    extend ActiveSupport::Concern


    included do

      before_create :init

      ## Spree
      field :spree_api_key, type: String
      field :spree_api_url, type: String, default: "http://localhost:3001"

      # Interpro <-> Producer
      has_and_belongs_to_many :producers,
        class_name: "User",
        inverse_of: :interpros,
        index: true

      # Interpro <-> WineData
      embeds_one :wine_data_element, class_name: "WineDataElement", inverse_of: :interpro, cascade_callbacks: true
    end


    def has_ecommerce?
      (self.spree_api_key  && self.spree_api_url) || false
    end


    private

    def init
      self.build_wine_data_element
    end
  end
end
