module Concerns
  module ProducerMixin
    extend ActiveSupport::Concern


    included do

      ## Offer
      field :discount, type: Integer, default: 0

      index "estates.company" => 1

      # Interpro <-> Producer
      has_and_belongs_to_many :interpros,
        class_name: "User",
        inverse_of: :producers,
        index: true

      # Producer <-> Estate
      embeds_many :estates, class_name: "Estate", inverse_of: :producer, cascade_callbacks: true


      # Producer <-> Contact
      embeds_one :contact, autobuild: true, cascade_callbacks: true
    end


    def contacted_by!(contact_params)
      contactor = contact_params[:contactor]
      comment = contact_params[:comment]
      self.contact.contactor = contactor.name
      self.contact.done = true
      self.contact.comment = comment
      self.contact.save
    end
  end
end
