class Favorite
  include Mongoid::Document
  include Mongoid::Timestamps
  include ActiveModel::ForbiddenAttributesProtection

  field :wine_id, type: Moped::BSON::ObjectId
  field :vintage_id, type: Moped::BSON::ObjectId
  field :reco_id, type: String

  validates_presence_of :wine_id
  validates_presence_of :vintage_id

  embedded_in :winewoo_user, class_name: "User", inverse_of: :favorites
end
