class GlobalWineData
  include Mongoid::Document
  include Mongoid::Timestamps
  include ActiveModel::ForbiddenAttributesProtection

  field :sparkling_types, type: Array, default: []
  field :culture_types, type: Array, default: []
  field :countries, type: Array, default: []
  field :ground_types, type: Array, default: []
  field :harvests, type: Array, default: []
  field :climates, type: Array, default: []
  field :allergens, type: Array, default: []
  field :ageing_methods, type: Array, default: []
  field :serving_temperatures, type: Array, default: []
  field :storage_durations, type: Array, default: []
  field :grapes, type: Array, default: []
  field :awards, type: Array, default: []
  field :notes, type: Array, default: []
  field :tasting_opportunities, type: Array, default: []
  field :tasting_profiles, type: Array, default: []

  def get_values_for(attr)
    self.read_attribute(attr).join(',')
  end

  def set_values_for(attr, values)
    self.write_attribute(attr, values.split(','))
  end
end
