class HistoryEntry
  include Mongoid::Document
  include Mongoid::Timestamps

  field :city, type: String, default: ""
  field :wine_id, type: Moped::BSON::ObjectId
  field :vintage_id, type: Moped::BSON::ObjectId
  field :reco_id, type: String

  validates_presence_of :wine_id
  validates_presence_of :vintage_id

  embedded_in :winewoo_user, class_name: "User", inverse_of: :history_entries
end
