class Picture
  include Mongoid::Document
  include Mongoid::Timestamps
  include ActiveModel::ForbiddenAttributesProtection

  mount_uploader :picture_file, PictureFileUploader

  field :title, type: String
  field :description, type: String
  field :status, type: Symbol

  embedded_in :user

  default_scope -> { order_by(created_at: :asc) }
end
