class WineDataElement
  include Mongoid::Document
  include Mongoid::Timestamps
  include ActiveModel::ForbiddenAttributesProtection

  field :appelations, type: Array, default: []
  field :production_areas, type: Array, default: []
  field :wine_colors, type: Array, default: []
  field :climates, type: Array, default: []
  field :tasting_profiles, type: Array, default: []
  field :grapes, type: Array, default: []

  embedded_in :interpro, class_name: "User", inverse_of: :wine_data_element

  def set_values!(appelations, production_areas, wine_colors, grapes, tasting_profiles, climates)
    set_values_for(:appelations, appelations)
    set_values_for(:production_areas, production_areas)
    self.wine_colors = wine_colors
    self.climates = climates
    self.tasting_profiles = tasting_profiles
    self.grapes = grapes
    self.save
  end

  def get_values_for(attr)
    (self.read_attribute(attr) || []).join(',')
  end

  private

  def set_values_for(attr, values)
    self.write_attribute(attr, values.split(','))
  end
end
