class WineNotification
  include Mongoid::Document
  include Mongoid::Timestamps
  include ActiveModel::ForbiddenAttributesProtection

  embedded_in :user

  field :trackable_parent_id,     type: Moped::BSON::ObjectId
  field :trackable_parent_type,   type: String
  field :trackable_parent_name,   type: String
  field :trackable_id,            type: Moped::BSON::ObjectId
  field :trackable_type,          type: String
  field :trackable_name,          type: String
  field :trackable_action,        type: Symbol
  field :author_id,               type: Moped::BSON::ObjectId
  field :author_name,             type: String
  # Not used field :values,                  type: Hash, default: {}
  field :status,                  type: Symbol, default: :unread

  validates_presence_of :trackable_type
  validates_presence_of :trackable_name
  validates_presence_of :trackable_action

  default_scope  -> { order_by(created_at: :desc) }

  def read!
    self.status = :read
    self.save!
  end
end
