class WinewooUserDevice
  include Mongoid::Document
  include Mongoid::Timestamps
  include ActiveModel::ForbiddenAttributesProtection

  default_scope -> { order_by(created_at: :asc) }

  field :device_model, type: String
  field :device_os, type: String
  field :device_os_version, type: String
  field :device_screen_width, type: Integer
  field :device_screen_height, type: Integer
  field :device_push_token, type: String
  field :device_lang, type: String

  embedded_in :winewoo_user, class_name: "User", inverse_of: :winewoo_user_devices

  validates_presence_of :device_model
  validates_presence_of :device_os
  validates_presence_of :device_os_version
  validates_presence_of :device_screen_width
  validates_presence_of :device_screen_height
  validates_presence_of :device_lang
end
