require "winewoo_core/engine"
require "winewoo_core/version"
require "winewoo_core/configuration"

module WinewooCore
  class << self

    attr_accessor :configuration


    # This is a test method used to test the gem
    # It returns the configured global variable hello_sentence.
    #
    def hello! ; self.configuration.hello_sentence end
    def authorizer ; self.configuration.authorizer end
    def cellar_repo ; self.configuration.cellar_repo end
    def comments_repo ; self.configuration.comments_repo end
    def criterions_repo ; self.configuration.criterions_repo end
    def favorites_repo ; self.configuration.favorites_repo end
    def history_repo ; self.configuration.history_repo end
    def log_repo ; self.configuration.log_repo end
    def producers_repo ; self.configuration.producers_repo end
    def users_repo ; self.configuration.users_repo end
    def vintages_repo ; self.configuration.vintages_repo end
    def wines_repo ; self.configuration.wines_repo end
    def winewoo_user_devices_repo ; self.configuration.winewoo_user_devices_repo end
    def winewoo_user_logs_repo ; self.configuration.winewoo_user_logs_repo end
    def winewoo_users_repo ; self.configuration.winewoo_users_repo end
    def feed_repo ; self.configuration.feed_repo  end
    def global_wine_data_repo ; self.configuration.global_wine_data_repo end
    def award_repo ; self.configuration.award_repo end


    def configuration
      @configuration ||= Configuration.new
    end


    def configure
      yield(configuration)
    end


    def reset
      @configuration = Configuration.new
    end
  end
end
