module WinewooCore::Models
  class WinewooUserParams

    attr_accessor :user_agent
    attr_accessor :device_push_token

    def initialize(params, user_agent)
      @params = params
      @user_agent = user_agent
      @device_push_token = @params[:device_push_token] || (@params[:winewoo_user_device] && @params[:winewoo_user_device][:device_push_token])
      if @params[:avatar]
        @params[:winewoo_user] ||= {}
        @params[:winewoo_user][:avatar] = @params[:avatar]
      end
    end


    def get
      return @params[:winewoo_user].blank? ? {} : permit_params
    end


    private

    def permit_params
      @params[:winewoo_user][:confirmed_at] = Time.now
      if @params[:winewoo_user][:avatar].present?
        @params[:winewoo_user][:avatar] = @params[:avatar]
        @params.require(:winewoo_user).permit!
      else
        @params.require(:winewoo_user)
          .permit(:email, :password, :password_confirmation, :status, :facebook_id,
        :twitter_id, :google_id, :linkedin_id, :name, :user_country, :user_city,
        :user_zip, :about, :interpro_ids => [], :producer_ids => [])
      end
    end
  end
end
