module WinewooCore::Repositories::Mongo
  class AwardMongoRepo

    def create(wine_id, vintage_id, award_params)
      return unless (wine_id && vintage_id)
      wine = Wine.find(wine_id)
      return unless wine
      vintage = wine.vintages.find(vintage_id)
      return unless vintage
      award = vintage.create_award(award_params)
      return award
    end


    def update(wine_id, vintage_id, award_params)
      return unless (wine_id && vintage_id)
      wine = Wine.find(wine_id)
      return unless wine
      vintage = wine.vintages.find(vintage_id)
      return unless vintage
      award = vintage.award
      return unless award
      award.update_attributes(award_params)
      return award
    end


    def destroy(wine_id, vintage_id)
      return unless (wine_id && vintage_id)
      wine = Wine.find(wine_id)
      return unless wine
      vintage = wine.vintages.find(vintage_id)
      return unless vintage
      award = vintage.award
      return unless award
      award.destroy
      return award
    end
  end
end
