module WinewooCore::Repositories::Mongo::Queries
  class InterproQuery < UserQuery


    def initialize
      super User.where(user_roles: :interpro)
    end


    def without_wines(interpro_id)
      wine_ids = WinewooCore::Repositories::Mongo::Queries::WineQuery
        .new
        .from_interpro(interpro_id)
        .map(&:interpro_id)

      @relation = @relation
        .where(:_id.nin => wine_ids)

      block_given? ?
        @relation.each { |user| yield user } :
        self
    end
  end
end
