module WinewooCore::Repositories::Mongo::Queries
  class WinewooQuery

    def initialize(relation)
      @relation = relation
    end

    def method_missing(method_name, *arguments, &block)
      @relation && @relation.send(method_name, *arguments, &block)
    end

    def respond_to?(method_name, include_private = false)
      @relation && @relation.respond_to?(method_name, include_private)
    end

    def respond_to_missing?(method_name, include_private = false)
      @relation && @relation.respond_to_missing?(method_name, include_private)
    end
  end
end
