module WinewooCore::Repositories::Mongo::Queries
  class WinewooUserQuery < UserQuery


    def initialize
      super User.where(user_roles: :winewoo_user)
    end


    def for_winewoo
      @relation = @relation
        .where(:interpro_ids.with_size => 0)

      block_given? ?
        @relation.each { |winewoo_user| yield winewoo_user } :
        self
    end


    def for_interpro(interpro_id)
      @relation = @relation
        .in(interpro_ids: BSON::ObjectId.from_string(interpro_id))

      block_given? ?
        @relation.each { |winewoo_user| yield winewoo_user } :
        self
    end


    def for_producer(producer_id)
      @relation = @relation
        .in(producer_ids: BSON::ObjectId.from_string(producer_id))

      block_given? ?
        @relation.each { |winewoo_user| yield winewoo_user } :
        self
    end


    def for_os(os)
      @relation = @relation
        .where(device_os: os)

      block_given? ?
        @relation.each { |winewoo_user| yield winewoo_user } :
        self
    end


    def with_push_token(token = nil)
      @relation = token ?
        @relation.where(device_push_token: token) :
        @relation.where(:device_push_token.exists => true)

      block_given? ?
        @relation.each { |winewoo_user| yield winewoo_user } :
        self
    end


    def with_email(email)
      @relation.where(email: email).first
    end
  end
end
