module WinewooCore::Repositories::Mongo
  class UsersMongoRepo

    def find(filters)
      query = WinewooCore::Repositories::Mongo::Queries::UserQuery.new(User.unscoped)
      query = query.with_role(filters.user_role) if filters.user_role
      query = filters.scope_recents ? query.order_by(updated_at: :desc) : query.order_by(created_at: :asc)
      users = query.page(filters.page || 1)
                      .per(filters.per_page || Kaminari::config.default_per_page)

      return users, query.count
    end


    def get(user_id)
      return user_id && User.find(user_id)
    end
  end
end
