require 'elasticsearch'

module WinewooCore::Services::ElasticSearch
  class NewsServices

    def initialize(with_error=false)
      @client = Elasticsearch::Client.new host: 'reco.kasual.biz:9200'
      @with_error = with_error
    end


    def fetch_news(page, per_page)
      from = page * per_page
      size = per_page
      raw = @client.search index: "my_twitter_river",
        body: request_body(from, size)

      Parsers::NewsParser.parse(raw["hits"]["hits"], @with_error)
    end


    def post_news(news_entry)
      @client.index index: "my_twitter_river",
        type: "winewoo_action",
        body: news_entry.to_h
    end


    private

    def request_body(from, size)
      {
        sort: [ { "created_at" => { order: "desc" } } ],
        from: from,
        size: size
      }
    end
  end
end
