module WinewooCore::Services::Finders::Comments
  class CommentsFinderBuilder

    def self.build(current_winewoo_user, wine_id, vintage_id, winewoo_user_id, filters)

      if wine_id
        if vintage_id
          return VintageCommentsFinder.new(wine_id, vintage_id, filters)
        else
          return WineCommentsFinder.new(wine_id, filters)
        end
      end

      if winewoo_user_id
        return WinewooUserCommentsFinder.new(winewoo_user_id, filters)
      end

      unless (wine_id || vintage_id || winewoo_user_id)
        return CurrentWinewooUserCommentsFinder.new(current_winewoo_user, filters)
      end
    end
  end
end
