module WinewooCore::Services::Finders::Comments
  class VintageCommentsFinder < CommentsFinder

    def initialize(wine_id, vintage_id, filters)
      super(filters)
      @wine_id = wine_id
      @vintage_id = vintage_id
    end


    def find
      return unless @wine_id && @vintage_id
      wine = Wine.find(@wine_id)
      return unless wine
      vintage = wine.vintages.find(@vintage_id)
      return unless vintage
      return vintage.user_comments
        .page(@page || 1)
        .per(@per_page || Kaminari::config.default_per_page)
    end
  end
end
