module WinewooCore::Services::Finders::Producers
  class WinewooCore::Services::Finders::Producers::ProducersFinderBuilder

    def self.build(filters)
      query = filters.query
      case query
      when nil
        AllProducersFinder.new(filters)
      else
        query.is_a?(String) ?
          KeywordsProducersFinder.new(filters) :
          FiltersProducersFinder.new(filters)
      end
    end
  end
end
