module WinewooCore::Services::Finders::Wines
  class AllWinesFinder < WinesFinder

    def find
      query = WinewooCore::Repositories::Mongo::Queries::WineQuery.new(Wine.unscoped).officials
      query = query.from_interpro(@interpro.id) if @interpro
      query = @filters.scope_recents ? query.order_by(updated_at: :desc) : query.order_by(created_at: :asc)
      wines = query.page(@page || 1)
        .per(@per_page || Kaminari::config.default_per_page)

      return wines, nil, query.count
    end
  end
end
