module WinewooCore::Services::Finders::Wines
  class ElasticsearchWinesFinder < WinesFinder

    def find
      Rails.logger.info "WINEWOO ELASTIC"

      page = (@page || 1).to_i
      per_page = (@per_page || Kaminari::config.default_per_page).to_i

      searcher = WinewooCore::Services::ElasticSearch::WinesServices.new
      wines = searcher.fetch_wines(@filters.query, page - 1, per_page)

      Rails.logger.info "WINEWOO #{wines.to_json}"

      # TODO find a way to get the total of results from elastic search
      return wines, "search"
    end
  end
end
