module WinewooCore::Services::Finders::Wines
  class WinesFinderBuilder

    def self.build(filters)
      if filters.list_of_wines
        ListOfWinesFinder.new(filters)
      else
        if filters.top_wines
          TopWinesFinder.new(filters)
        else
          query = filters.query
          case query
          when nil
            if filters.producer
              ProducerWinesFinder.new(filters)
            elsif filters.interpro
              InterproWinesFinder.new(filters)
            else
              # NullWinesFinder.new
              AllWinesFinder.new(filters)
            end
          else
            Rails.logger.info "WINEWOO #{query} - #{filters.to_json}"
            query.is_a?(String) ?
              (filters.interpro ? KeywordsWinesFinder.new(filters) : ElasticsearchWinesFinder.new(filters)) :
              FiltersWinesFinder.new(filters)
          end
        end
      end
    end
  end
end
