module WinewooCore::UseCases
  class Admins::GlobalWineData::UpdateWineData < BaseUseCase

    def initialize(current_user, log_params=nil)
      super(WinewooCore.global_wine_data_repo.new, log_params)
      self.current_caller = current_user
    end


    def call(wine_data_id, data_params)
      global_wine_data = self.repo.get(wine_data_id)
      return unless authorize_wine_data_show(global_wine_data, &Proc.new)

      global_wine_data = self.repo.update(wine_data_id, data_params)

      yield global_wine_data ?
        UseCaseResults.success(global_wine_data) :
        UseCaseResults.not_found
    end


    private

    def authorize_wine_data_show(global_wine_data)
      auth_params = authorization_params_for(:global_wine_data, :update?, global_wine_data)
      res = self.authorizer.authorize_action(auth_params)
      yield UseCaseResults.unauthorized unless res
      return res
    end
  end
end
