module WinewooCore::UseCases
  class BaseUseCase

    def initialize(repository, log_params=nil)
      @repo = repository
      @log_repo = WinewooCore::Repositories::Mongo::WinewooUserLogsMongoRepo.new
      @log_params = log_params
      @authorizer = WinewooCore.authorizer.new
    end


    attr_accessor :repo
    attr_accessor :log_repo
    attr_accessor :log_params
    attr_accessor :authorizer
    attr_accessor :current_caller


    protected

    def authorization_params_for(resource_type, action, resource=nil)
      WinewooCore::Services::Authorizers::AuthorizationParams.new.tap do |auth|
        auth.caller = self.current_caller
        auth.resource = resource
        auth.resource_type = resource_type
        auth.action = action
      end
    end
  end
end
