module WinewooCore::UseCases
  class UseCaseResults

    def self.found(resource, meta = nil) new(:found, resource).tap {|i| i.meta = meta} end

    def self.not_found() new(:not_found) end

    def self.success(resource = nil) new(:success, resource) end

    def self.failure(resource = nil) new(:failure, resource) end

    def self.unauthorized(resource = nil) new(:unauthorized, resource) end


    attr_accessor :resource
    attr_accessor :result
    attr_accessor :meta


    def initialize(result, resource = nil)
      @result = result
      @resource = resource
    end


    def on_found
      yield resource, meta if @result == :found
    end


    def on_not_found
      yield if @result == :not_found
    end


    def on_unauthorized
      yield if @result == :unauthorized
    end


    def on_success
      if @result == :success
        if @resource
          yield @resource
        else
          yield
        end
      end
    end


    def on_failure
      if @result == :failure
        if @resource
          yield @resource
        else
          yield
        end
      end
    end
  end
end
