module WinewooCore::UseCases
  class Users::ListUsers < BaseUseCase

    def initialize(current_user)
      super(WinewooCore.users_repo.new)
      self.current_caller = current_user
    end


    def call(filters)
      return unless authorize_users_index(&Proc.new)

      users, total = self.repo.find(filters)

      yield users ?
        UseCaseResults.found(users, total) :
        UseCaseResults.failure
    end


    private

    def authorize_users_index
      auth_params = authorization_params_for(:user, :index?)
      res = self.authorizer.authorize_action(auth_params)
      yield UseCaseResults.unauthorized unless res
      return res
    end
  end
end
