module WinewooCore::UseCases
  class Users::ShowUser < BaseUseCase

    def initialize(current_user, log_params=nil)
      super(WinewooCore.users_repo.new, log_params)
      self.current_caller = current_user
    end


    def call(user_id)
      user = (user_id == 'me') ? self.current_caller : self.repo.get(user_id)

      return unless authorize_user_show(user, &Proc.new)

      yield user ?
        UseCaseResults.found(user) :
        UseCaseResults.not_found
    end


    private

    def authorize_user_show(user)
      auth_params = authorization_params_for(:user, :show?, user)
      res = self.authorizer.authorize_action(auth_params)
      yield UseCaseResults.unauthorized unless res
      return res
    end
  end
end
