module WinewooCore::UseCases
  class Wines::ShowWine < BaseUseCase

    def initialize(current_user, log_params=nil)
      super(WinewooCore.wines_repo.new, log_params)
      self.current_caller = current_user
    end


    def call(wine_id, options={})
      wine = self.repo.get(wine_id)

      return unless authorize_wine_show(wine, &Proc.new)

      wine = nil if wine && wine.draft? && options[:only_published]
      # TODO UNOFFICIALS
      # wine = nil if wine && wine.unofficial? && options[:only_published]

      yield wine ?
        UseCaseResults.found(wine) :
        UseCaseResults.not_found
    end


    private

    def authorize_wine_show(wine)
      auth_params = authorization_params_for(:wine, :show?, wine)
      res = self.authorizer.authorize_action(auth_params)
      yield UseCaseResults.unauthorized unless res
      return res
    end
  end
end
