module WinewooCore::UseCases
  class WinewooUser::Account::AuthenticateWithOauth < BaseUseCase

    def initialize(log_params=nil)
      super(WinewooCore.winewoo_users_repo.new, log_params)
    end


    def call(winewoo_user_params)
      winewoo_user = self.repo.create(winewoo_user_params)

      yield winewoo_user.persisted? && winewoo_user.winewoo_user_devices.any? ?
        UseCaseResults.success(winewoo_user) :
        UseCaseResults.failure(winewoo_user.errors)
    end
  end
end
