module WinewooCore::UseCases
  class WinewooUser::Account::CreateWinewooUserForInterpro < BaseUseCase

    def initialize(log_params=nil)
      super(WinewooCore::Repositories::Mongo::InterproWinewooUsersMongoRepo.new, log_params)
    end


    def call(current_interpro, winewoo_user_params)
      wuser, device = self.repo.create(current_interpro, winewoo_user_params)

      yield (wuser.valid? && device.valid? ) ?
        UseCaseResults.success(wuser) :
        UseCaseResults.failure(wuser.errors.to_a.concat(device.errors.to_a))
    end
  end
end
