module WinewooCore::UseCases
  class WinewooUser::Account::UpdateWinewooUser < BaseUseCase

    def initialize(log_params=nil)
      super(WinewooCore.winewoo_users_repo.new, log_params)
    end


    def call(winewoo_user_id, winewoo_user_params)
      winewoo_user = self.repo.update(winewoo_user_id,
                                      winewoo_user_params)

      yield winewoo_user ?
        (winewoo_user.errors.blank? ?
         UseCaseResults.success(winewoo_user) :
         UseCaseResults.failure(winewoo_user.errors)) :
        UseCaseResults.not_found
    end
  end
end
