module WinewooCore::UseCases
  class WinewooUser::Cellar::RemoveCellarEntry < BaseUseCase

    def initialize(log_params=nil)
      super(WinewooCore.cellar_repo.new, log_params)
    end


    def call(winewoo_user, entry_id)
      entry = self.repo.destroy(winewoo_user, entry_id)
      self.log_repo.create(complete_log_params(entry)) if entry

      yield entry ?
        UseCaseResults.success(entry) :
        UseCaseResults.not_found
    end


    private

    def complete_log_params(entry)
      wine = WinewooCore.wines_repo.new.get(entry.wine_id)
      self.log_params.params = {
        "action" => "uncellar_wine",
        "wine_id" => entry.wine_id,
        "vintage_id" => entry.vintage_id,
        "producer_id" => wine.official? ? wine.producer.id : nil
      }
      return self.log_params
    end
  end
end
