module WinewooCore::UseCases
  class WinewooUser::Comments::ListComments < BaseUseCase

    def initialize(log_params=nil)
      super(WinewooCore.comments_repo.new, log_params)
    end


    def call(current_winewooer, wine_id, vintage_id, winewoo_user_id, filters)
      comments = self.repo.find(current_winewooer, wine_id, vintage_id, winewoo_user_id, filters)

      yield comments ?
        UseCaseResults.success(comments) :
        UseCaseResults.not_found
    end
  end
end
