module WinewooCore::UseCases
  class WinewooUser::Comments::ShowComment < BaseUseCase

    def initialize(log_params=nil)
      super(WinewooCore.comments_repo.new, log_params)
    end


    def call(wine_id, vintage_id, comment_id)
      comment = self.repo.show(wine_id, vintage_id, comment_id)

      yield comment ?
        UseCaseResults.success(comment) :
        UseCaseResults.not_found
    end
  end
end
