module WinewooCore::UseCases
  class WinewooUser::Comments::UpdateComment < BaseUseCase

    def initialize(log_params=nil)
      super(WinewooCore.comments_repo.new, log_params)
    end


    def call(wine_id, vintage_id, comment_id, comment_params)
      comment = self.repo.update(wine_id,
                               vintage_id,
                               comment_id,
                               comment_params)

      yield comment ?
        (comment.errors.blank? ?
         UseCaseResults.success(comment) :
         UseCaseResults.failure(comment.errors)) :
        UseCaseResults.not_found
    end
  end
end
