module WinewooCore::UseCases
  class WinewooUser::Devices::UpdateWinewooUserDevice < BaseUseCase

    def initialize(log_params=nil)
      super(WinewooCore.winewoo_user_devices_repo.new, log_params)
    end


    def call(winewoo_user, winewoo_user_device_id, winewoo_user_params)
      winewoo_user_device = self.repo.update(winewoo_user,
                                             winewoo_user_device_id,
                                             winewoo_user_params)

      yield winewoo_user_device ?
        (winewoo_user_device.errors.blank? ?
         UseCaseResults.success(winewoo_user_device) :
         UseCaseResults.failure(winewoo_user_device.errors)) :
        UseCaseResults.not_found
    end
  end
end
