module WinewooCore::UseCases
  class WinewooUser::Logs::CreateWinewooUserLog < BaseUseCase

    def initialize(log_params=nil)
      super(WinewooCore.winewoo_user_logs_repo.new, log_params)
    end


    def call(log_params)
      log = self.repo.create(log_params)

      yield log.persisted? ?
        UseCaseResults.success(log) :
        UseCaseResults.failure(log.errors)
    end
  end
end
